--[[
  Tattersail's Incoming Heals for CT_RaidAssist
  Requires: CT_RaidAssist
  
  Written by: Tattersail <Rise and Shine> on Twisting Nether (EU)

--]]

IH_VERSION = 29
IH_TITLE = "Rise and Shine Incoming Heals"
IH_COLOR_CODE = "00FF00"

IH_AUTHOR_NAME = "Tattersail"
IH_AUTHOR_GUILD = "Rise and Shine"
IH_AUTHOR_REALM = "Twisting Nether EU"


IH_TIMEOUT = 8
IH_RESTIMEOUT = 20
IH_CHECKHEALS_TIMER = 30
IH_MIN_LOSS_SHOW = 1000 -- players with -HP > X will show IH if ShowMissing is enabled
IH_TOO_LOW_MINUS_HEAL = 0.6 -- heals that hit for less than minimum * X are ignored in +healing calculations (probably target has MS or curse)

IH_IncomingHeals = { }
IH_OutgoingHeals = { }
IH_OutgoingResses = { }
IH_KnownUsers = { }
IH_Emergency = { } -- cache for CTRA Emergency: name --> frame id

IH_ShowIncoming = false
IH_ShowOutgoing = false
IH_ShowMissing = true

IH_LastSpell = nil



function IH_OnVariablesLoaded()
  SLASH_IH1 = "/"..TEXT__IH
  SLASH_IH2 = "/"..TEXT__INCOMINGHEALS
  SlashCmdList["IH"] = IH_SlashHandler

  for i = 1, 40 do
    getglobal("CT_RAMember"..i.."_IH"):SetBackdropColor(0, 0, 0, 1)
--    getglobal("CT_RAMember"..i.."_IH"):Hide()
    getglobal("CT_RAMember"..i.."_OH"):SetBackdropColor(0, 0, 0, 1)
--    getglobal("CT_RAMember"..i.."_OH"):Hide()
    getglobal("CT_RAMember"..i.."_OHText"):SetTextColor(0, 1, 0)
  end
  
  for i = 1, 5 do
    getglobal("CT_RA_EmergencyFrameFrame"..i.."_IH"):SetBackdropColor(0, 0, 0, 1)
--    getglobal("CT_RA_EmergencyFrameFrame"..i.."_IH"):Hide()
  end

  for i = 1, 10 do
    getglobal("CT_RAMTGroupMember"..i.."MTTT_IH"):SetBackdropColor(0, 0, 0, 1)
--    getglobal("CT_RAMTGroupMember"..i.."MTTT_IH"):Hide()
    getglobal("CT_RAPTGroupMember"..i.."_IH"):SetBackdropColor(0, 0, 0, 1)
--    getglobal("CT_RAPTGroupMember"..i.."_IH"):Hide()
  end

  hook("CT_RA_SpellStartCast", IH_CT_RA_SpellStartCast_New, 1)
  hook("CT_RA_SpellEndCast", IH_CT_RA_SpellEndCast_New, 1)
  hook("CT_RA_ParseMessage", IH_CT_RA_ParseMessage_New, 1)
  hook("CT_RA_AddMessage", IH_CT_RA_AddMessage_New, 200)
  hook("CT_RA_UpdateUnitHealth", IH_CT_RA_UpdateUnitHealth_New, 1)
  hook("CT_RA_Emergency_UpdateHealth", IH_CT_RA_Emergency_UpdateHealth_New, 200)
  hook("CT_RA_UpdateMTTT", IH_CT_RA_UpdateMTTT_New, 200)
  hook("CT_RA_UpdatePT", IH_CT_RA_UpdatePT_New, 200)
  hook("CastSpell", IH_CastSpell_New, 200)
  hook("CastSpellByName", IH_CastSpellByName_New, 200)
  hook("UseAction", IH_UseAction_New, 1)
  hook("CT_RA_UpdateUnitDead", IH_CT_RA_UpdateUnitDead_New, 200)

  scheduleRepeat("IH_CheckHeals", IH_CHECKHEALS_TIMER, IH_CheckHeals)

  schedule(2, echo, "|c00"..IH_COLOR_CODE..IH_TITLE.."|r "..TEXT__VERSION.." "..IH_VERSION.." "..TEXT__INITIALIZED)
end




--[[

  Spell detection part.
  Many thanks to the CT_RaidAssist team.

--]]


function IH_CastSpell_New(spellId, spellbookTabNum)
  local oldval = GetCVar("UberTooltips")
  SetCVar("UberTooltips", 1)
  CT_RADST:SetSpell(spellId, spellbookTabNum)
  IH_ParseTooltip()
  SetCVar("UberTooltips", oldval)
end

function IH_CastSpellByName_New(spellName)
  local _, _, spellname = string.find(spellName, "^([^%(]+) %(");
  local _, _, ranktext = string.find(spellName, "%(([^%(]+)%)");

  if not spellname then
    spellname = spellName
  end

  local spelldata = IH_SpellData[spellname]
  local rankdata = nil
  
  if spelldata then

    if ranktext then
      rankdata = spelldata.ranks[ranktext]

    else
      local maxamount = 0
      for rt, rd in spelldata.ranks do
        if rd.amount and rd.amount > maxamount then
          rankdata = rd
          ranktext = rt
          maxamount = rd.amount
        end
      end
    end

    if not ranktext then
      ranktext = "unknown"
      rankdata = spelldata.ranks[ranktext]
    end

    if not rankdata then
      rankdata = { plushealing = 0, amount = 0, minimum = -200, maximum = 200 }
      spelldata.ranks[ranktext] = rankdata
    end


    IH_LastSpell = {
      spellname = spellname,
      ranktext = ranktext,
      spelldata = spelldata,
      rankdata = rankdata,
    }
  end
end


function IH_UseAction_New(a1, a2, a3)
  local oldval = GetCVar("UberTooltips")
  SetCVar("UberTooltips", 1)
  CT_RADST:SetAction(a1)
  IH_ParseTooltip()
  SetCVar("UberTooltips", oldval)
end


function IH_ParseTooltip()
  local spellname = CT_RADSTTextLeft1:GetText()
  local spelldata = IH_SpellData[spellname]
  if not spelldata then
    IH_LastSpell = nil
    return
  end
  
  local minmaxtext = CT_RADSTTextLeft4:GetText()
  if not minmaxtext then minmaxtext = CT_RADSTTextLeft3:GetText() end
  
  local _, _, minimum, maximum = string.find(minmaxtext, IH_TOOLTIP_REGEXP)

  local ranktext = minimum
  local rankdata = spelldata.ranks[ranktext]
  
  if not rankdata then
    rankdata = { plushealing = 0 }
    spelldata.ranks[ranktext] = rankdata
  end

  rankdata.minimum = tonumber(minimum)
  rankdata.maximum = tonumber(maximum)
  rankdata.amount = floor((minimum + maximum) / 2)

  IH_LastSpell = {
    spellname = spellname,
    ranktext = ranktext,
    spelldata = spelldata,
    rankdata = rankdata,
  }
  
end


function IH_CT_RA_SpellStartCast_New(spell)
  if IH_LastSpell then
    local spelldata = IH_LastSpell.spelldata
    local rankdata = IH_LastSpell.rankdata
    local amount = rankdata.amount + rankdata.plushealing
    if
      spelldata.bol and
      CT_RA_Stats[IH_LastSpell.target] and
      CT_RA_Stats[IH_LastSpell.target]["Buffs"] and
      CT_RA_Stats[IH_LastSpell.target]["Buffs"][IH_BLESSING_OF_LIGHT]
    then
      amount = amount + spelldata.bol
    end
    IH_LastSpell.amount = amount
    if spelldata.party then
      local targets = { UnitName("player") }
      for i = 1, GetNumPartyMembers() do
        table.insert(targets, UnitName("party"..i))
      end
      IH_LastSpell.target = string.join(targets, " ")
    else
      IH_LastSpell.target = spell[2]
    end
    if IH_LastSpell.target then
      CT_RA_SendMessage("IHN "..amount.." "..arg2.." "..IH_LastSpell.target, true)
    else
      IH_LastSpell = nil
    end
  end
end

function IH_CT_RA_SpellEndCast_New()
  if (event == "SPELLCAST_INTERRUPTED" or event == "SPELLCAST_FAILED") and IH_LastSpell and IH_LastSpell.target and IH_LastSpell.amount then
    CT_RA_SendMessage("IHS "..IH_LastSpell.amount.." "..IH_LastSpell.target, true)
  end
end


function IH_OnMsgSpellSelfBuff()
  if not IH_LastSpell then return end

  -- detect +healing
  local _, _, spellname, target, amount = string.find(arg1, IH_PLUSHEALING_REGEXP)
  if target == "you" then target = UnitName("player") end
  if IH_LastSpell.spellname ~= spellname then return end

  amount = tonumber(amount)

  local rankdata = IH_LastSpell.rankdata
  local spelldata = IH_LastSpell.spelldata
  if
    spelldata.bol and
    CT_RA_Stats[target] and
    CT_RA_Stats[target]["Buffs"] and
    CT_RA_Stats[target]["Buffs"][IH_BLESSING_OF_LIGHT]
  then
    amount = amount - spelldata.bol
  end

  -- calculate + heal
  if amount > rankdata.maximum then rankdata.plushealing = max(rankdata.plushealing, amount - rankdata.maximum) end

  -- calculate - heal
  if amount < rankdata.minimum + rankdata.plushealing and amount > (rankdata.minimum + rankdata.plushealing) * IH_TOO_LOW_MINUS_HEAL then
    rankdata.plushealing = min(0, amount - rankdata.maximum)
  end

end



--[[

  Parse incoming CT_RaidAssist and IncomingHeals messages.

  RES <player>
  RESNO
  IHN <amount> <casttime> <player>
  IHH <amount> <duration> <player>
  IHS <amount> <player>
  IHV <version>
  
  RES - starts res on <player>
  RESNO - stop ressing
  IHN - normal heal
  IHH - HoT - not implemented yet. impossible atm.
  IHS - stop heal - only used when interrupted. 
  
--]]

function IH_CT_RA_ParseMessage_New(source, msg)
  if string.sub(msg, 1, 4) == "RES " then
    local _, _, target = string.find(msg, "^RES (.+)$");
    
    if not IH_OutgoingResses[source] then IH_OutgoingResses[source] = { } end
    local outres = IH_OutgoingResses[source]
    outres.target = target
    outres.time = GetTime()
    
    local raidid = GetPlayerRaidID(target)
    if raidid then
      getglobal("CT_RAMember"..raidid.."_IH"):Show()
      getglobal("CT_RAMember"..raidid.."_IHText"):SetText("RI")
      getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(1, 1, 0)
    end

  elseif string.sub(msg, 1, 5) == "RESNO" then
    local outres = IH_OutgoingResses[source]
    if outres and outres.target then
      local target = outres.target
      local moreres = false
      outres.target = false
      
      for source, outres in IH_OutgoingResses do
        if outres.target and outres.target == target then moreres = true end
      end

      if not moreres then
        local raidid = GetPlayerRaidID(target)
        if raidid then
          getglobal("CT_RAMember"..raidid.."_IH"):Hide()
        end
      end
    end

  elseif string.sub(msg, 1, 4) == "IHN " then
    if not IH_KnownUsers[source] then IH_KnownUsers[source] = 7 end
    IH_FinishHeal(source)

    local _, _, amount, casttime, target = string.find(msg, "^IHN (%d+) (%d+) (.+)$")
    if amount and casttime and target then
    
      local targets = string.split(target, " ")
      if table.getn(targets) > 1 then target = "multiple" end

      if not IH_OutgoingHeals[source] then IH_OutgoingHeals[source] = { } end
      local oh = IH_OutgoingHeals[source]
      oh.targets = targets
      oh.amount = amount
      oh.time = GetTime()
      
      scheduleByName("IHO_"..source, min(casttime / 1000, IH_TIMEOUT), IH_FinishHeal, source)

      if IH_ShowOutgoing then
        local raidid = GetPlayerRaidID(source)
        if raidid then
          getglobal("CT_RAMember"..raidid.."_OH"):Show()
          getglobal("CT_RAMember"..raidid.."_OHText"):SetText("-> "..target)
        end
      end


      if IH_ShowIncoming then
        for index, target in targets do
          local raidid = GetPlayerRaidID(target)
          if raidid then

            if not IH_IncomingHeals[target] then IH_IncomingHeals[target] = { } end
            local ih = IH_IncomingHeals[target]
            if not ih.amount then ih.amount = 0 end
            ih.amount = ih.amount + amount
            ih.time = GetTime()

            scheduleByName("IHI_"..target, IH_TIMEOUT, IH_TimeoutIncomingHeal, target)

            local amount =  ih.amount - UnitHealthMax("raid"..raidid) + UnitHealth("raid"..raidid)
            local showamount = amount
            if not IH_ShowMissing then showamount = ih.amount end
            getglobal("CT_RAMember"..raidid.."_IH"):Show()
            getglobal("CT_RAMember"..raidid.."_IHText"):SetText(string.format("%.1f", showamount / 1000))
            if amount > 0 then
              getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(0, 1, 0)
            else
              getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(1, 1, 1)
            end

            if CT_RA_Emergency_Units[target] then IH_UpdateEmergency(target) end

          end

          IH_UpdateMTTTs()
          IH_UpdatePTs()
        end
      end

    end

    return
    
  elseif string.sub(msg, 1, 4) == "IHV " then
    local _, _, version = string.find(msg, "^IHV (%d+)$")
    IH_KnownUsers[source] = tonumber(version)
    return
  
  elseif string.sub(msg, 1, 4) == "IHS " then
    local _, _, amount, targets = string.find(msg, "^IHS (%d+) (.+)$")
    
    IH_FinishHeal(source)
    return
  
  end
end

function IH_TimeoutIncomingHeal(target)
  local ih = IH_IncomingHeals[target]
  if ih and ih.amount and ih.time + IH_TIMEOUT < GetTime() then
    IH_IncomingHeals[target].amount = false
    local raidid = GetPlayerRaidID(target)
    if raidid then getglobal("CT_RAMember"..raidid.."_IH"):Hide() end
    if CT_RA_Emergency_Units[target] then IH_UpdateEmergency(target) end
    IH_UpdateMTTTs()
    IH_UpdatePTs()
  end
end


--[[
  Removes an amount from an incoming heal and updates the text in the CTRA member window
--]]
function IH_FinishHeal(source)
  unscheduleByName("IHO_"..source)
  
  if IH_ShowOutgoing then
    local raidid = GetPlayerRaidID(source)
    if raidid then
      getglobal("CT_RAMember"..raidid.."_OH"):Hide()
    end
  end

  local oh = IH_OutgoingHeals[source]
  if oh and oh.targets then
    for index, target in oh.targets do
      local ih = IH_IncomingHeals[target]
      local raidid = GetPlayerRaidID(target)

      if ih and ih.amount then
        ih.amount = ih.amount - oh.amount
      end
      
      if raidid then
        if (IH_ShowMissing and UnitHealth("raid"..raidid) < UnitHealthMax("raid"..raidid) - IH_MIN_LOSS_SHOW and not UnitIsDeadOrGhost("raid"..raidid)) or
            (ih and ih.amount and ih.amount > 0)
        then

          local amount =  UnitHealth("raid"..raidid) - UnitHealthMax("raid"..raidid)
          if ih and ih.amount then amount = ih.amount + amount end
          local showamount = amount
          if not IH_ShowMissing then showamount = ih.amount end
          getglobal("CT_RAMember"..raidid.."_IH"):Show()
          getglobal("CT_RAMember"..raidid.."_IHText"):SetText(string.format("%.1f", showamount / 1000))
          if amount > 0 then
            getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(0, 1, 0)
          else
            getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(1, 1, 1)
          end
        else
          getglobal("CT_RAMember"..raidid.."_IH"):Hide()
        end
      end

      if CT_RA_Emergency_Units[target] then IH_UpdateEmergency(target) end
    end
    IH_UpdateMTTTs()
    IH_UpdatePTs()
    oh.targets = nil
  end


end

--[[
  Periodically checks all incoming and outgoing heals.
  Lag and bugs can cause values to become "stuck".
  This check should detect this and remove them.
--]]

function IH_CheckHeals()
  for source, oh in IH_OutgoingHeals do
    if oh.targets and oh.time + IH_TIMEOUT < GetTime() then
      IH_FinishHeal(source)
    end
  end
  
  for target, ih in IH_IncomingHeals do
    IH_TimeoutIncomingHeal(target)
  end
  
  for source, outres in IH_OutgoingResses do
    if outres.target and outres.time + IH_RESTIMEOUT < GetTime() then
      local target = outres.target
      local moreres = false
      outres.target = false
      
      for source, outres in IH_OutgoingResses do
        if outres.target and outres.target == target then moreres = true end
      end

      if not moreres and (not IH_IncomingHeals[target] or not IH_IncomingHeals[target].amount) then
        local raidid = GetPlayerRaidID(target)
        if raidid then
          getglobal("CT_RAMember"..raidid.."_IH"):Hide()
        end
      end
    end
  end
  
  for raidid = 1, GetNumRaidMembers() do
    local name = GetRaidRosterInfo(raidid)
    
    if getglobal("CT_RAMember"..raidid.."_IH"):IsVisible() then
      local hide = true
      if IH_IncomingHeals[name] and IH_IncomingHeals[name].amount then hide = false end
      if UnitHealth("raid"..raidid) < UnitHealthMax("raid"..raidid) - IH_MIN_LOSS_SHOW then hide = false end
      if hide then
        for source, outres in IH_OutgoingResses do
          if outres and outres.target == name then hide = false end
        end
      end
      if not IH_ShowMissing then hide = true end
      if hide then
        getglobal("CT_RAMember"..raidid.."_IH"):Hide()
      end
    end
    
    if getglobal("CT_RAMember"..raidid.."_OH"):IsVisible() then
      local hide = true
      for source, oh in IH_OutgoingHeals do
        if oh and oh.targets and table.getkey(oh.targets, name) then hide = false end
      end
      if hide then
        getglobal("CT_RAMember"..raidid.."_OH"):Hide()
      end
    end
  end
end


--[[
  Update the color of the IH number
--]]
function IH_CT_RA_UpdateUnitHealth_New(frame)
  local raidid = frame:GetID()
  local name = GetRaidRosterInfo(raidid)
  local ih = IH_IncomingHeals[name]
  

  if (IH_ShowMissing and UnitHealth("raid"..raidid) < UnitHealthMax("raid"..raidid) - IH_MIN_LOSS_SHOW and not UnitIsDeadOrGhost("raid"..raidid)) or
       (ih and ih.amount and ih.amount > 0)
  then
    local amount =  UnitHealth("raid"..raidid) - UnitHealthMax("raid"..raidid)
    if ih and ih.amount then amount = ih.amount + amount end
    local showamount = amount
    if not IH_ShowMissing then showamount = ih.amount end
    getglobal("CT_RAMember"..raidid.."_IH"):Show()
    getglobal("CT_RAMember"..raidid.."_IHText"):SetText(string.format("%.1f", showamount / 1000))
    if amount > 0 then
      getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(0, 1, 0)
    else
      getglobal("CT_RAMember"..raidid.."_IHText"):SetTextColor(1, 1, 1)
    end
    IH_UpdateEmergency(name)
    IH_UpdateMTTTs()
    IH_UpdatePTs()
  else
    getglobal("CT_RAMember"..raidid.."_IH"):Hide()
  end
end

function IH_CT_RA_UpdateUnitDead_New(frame, didUpdateHealth)
  local raidid = frame.id
  if UnitIsDeadOrGhost("raid"..raidid) then
    getglobal("CT_RAMember"..raidid.."_IH"):Hide()
  end
end


--[[
  Update the IH numbers on CTRA Emergency Monitor
--]]

function IH_CT_RA_Emergency_UpdateHealth_New()
  IH_Emergency = { }

  for i = 1, 5 do
    if getglobal("CT_RA_EmergencyFrameFrame"..i):IsVisible() then
      local name = getglobal("CT_RA_EmergencyFrameFrame"..i.."Name"):GetText()
      IH_Emergency[name] = i
      IH_UpdateEmergency(name)
    end
  end
end


function IH_UpdateEmergency(name)
  if not IH_Emergency[name] then return end
  local framename = "CT_RA_EmergencyFrameFrame"..IH_Emergency[name]
  
  if IH_IncomingHeals[name] and IH_IncomingHeals[name].amount then
    local ih = IH_IncomingHeals[name]

    if ih.amount == 0 then
      getglobal(framename.."_IH"):Hide()

    else
      local raidid = getglobal(framename.."ClickFrame").unitid

      local amount =  ih.amount - UnitHealthMax(raidid) + UnitHealth(raidid)
      local showamount = amount
      if not IH_ShowMissing then showamount = ih.amount end
      getglobal(framename.."_IH"):Show()
      getglobal(framename.."_IHText"):SetText(string.format("%.1f", showamount / 1000))
      if amount > 0 then
        getglobal(framename.."_IHText"):SetTextColor(0, 1, 0)
      else
        getglobal(framename.."_IHText"):SetTextColor(1, 1, 1)
      end

    end        

  else
    getglobal(framename.."_IH"):Hide()

  end
end





--[[    MTTT display    ]]--

function IH_UpdateMTTTs()
  for i = 1, 10 do
    getglobal("CT_RAMTGroupMember"..i.."MTTT").unitName = nil
  end
  CT_RA_UpdateMTTTs()
end

function IH_CT_RA_UpdateMTTT_New(raidid, mtid, frame, height, key, val)
  local framename = frame:GetName()
  local name = UnitName(raidid)

  if IH_IncomingHeals[name] and IH_IncomingHeals[name].amount then
    local ih = IH_IncomingHeals[name]

    if ih.amount == 0 then
      getglobal(framename.."_IH"):Hide()

    else
      local amount =  ih.amount - UnitHealthMax(raidid) + UnitHealth(raidid)
      local showamount = amount
      if not IH_ShowMissing then showamount = ih.amount end
      getglobal(framename.."_IH"):Show()
      getglobal(framename.."_IHText"):SetText(string.format("%.1f", showamount / 1000))
      if amount > 0 then
        getglobal(framename.."_IHText"):SetTextColor(0, 1, 0)
      else
        getglobal(framename.."_IHText"):SetTextColor(1, 1, 1)
      end

    end        

  else
    getglobal(framename.."_IH"):Hide()

  end  
end



--[[    PT display    ]]--

function IH_UpdatePTs()
  for i = 1, 10 do
    getglobal("CT_RAPTGroupMember"..i).unitName = nil
  end
  CT_RA_UpdatePTs()
end

function IH_CT_RA_UpdatePT_New(raidid, frame, height, key, val)
  local framename = frame:GetName()
  local name = UnitName(raidid)

  if IH_IncomingHeals[name] and IH_IncomingHeals[name].amount then
    local ih = IH_IncomingHeals[name]

    if ih.amount == 0 then
      getglobal(framename.."_IH"):Hide()

    else
      local amount =  ih.amount - UnitHealthMax(raidid) + UnitHealth(raidid)
      local showamount = amount
      if not IH_ShowMissing then showamount = ih.amount end
      getglobal(framename.."_IH"):Show()
      getglobal(framename.."_IHText"):SetText(string.format("%.1f", showamount / 1000))
      if amount > 0 then
        getglobal(framename.."_IHText"):SetTextColor(0, 1, 0)
      else
        getglobal(framename.."_IHText"):SetTextColor(1, 1, 1)
      end

    end        

  else
    getglobal(framename.."_IH"):Hide()

  end  
end



--[[
  Manual reset of all incoming and outgoing heals.
--]]
function IH_Reset()
  IH_IncomingHeals = { }
  IH_OutgoingHeals = { }
  IH_OutgoingResses = { }

  for i = 1, 40 do
    getglobal("CT_RAMember"..i.."_OH"):Hide()
    getglobal("CT_RAMember"..i.."_IH"):Hide()
  end
  for i = 1, 5 do
    getglobal("CT_RA_EmergencyFrameFrame"..i.."_IH"):Hide()
  end
  for i = 1, 10 do
    getglobal("CT_RAMTGroupMember"..i.."MTTT_IH"):Hide()
    getglobal("CT_RAPTGroupMember"..i.."_IH"):Hide()
  end

end



--[[
  Sends IHV when CT_RaidAssist sends V
--]]
function IH_CT_RA_AddMessage_New(msg)
  if string.sub(msg, 1, 1) == "V" then
    CT_RA_AddMessage("IHV "..IH_VERSION)
  end
end



function GetPlayerRaidID(playername)
  for i = 1, GetNumRaidMembers(), 1 do
    local name, rank, _, _, _, _, _, _, _ = GetRaidRosterInfo(i)
    if playername == name and rank then
      return i
    end
  end
  return nil
end





function IH_SlashHandler(msg)
  if msg == TEXT__IN then IH_SwitchInDisplay()
  elseif msg == TEXT__MISSING then IH_SwitchMissingDisplay()
  elseif msg == TEXT__OUT then IH_SwitchOutDisplay()
  elseif msg == TEXT__RESET then IH_Reset()
  elseif msg == TEXT__USERS then IH_ShowUsers()
  elseif msg == TEXT__VERSION then IH_ShowVersion()
  else IH_ShowHelp()
  end
end


function IH_SwitchInDisplay()
  if IH_ShowIncoming then
    echo(TEXT_INCOMING_HEALS_DISPLAY_TURNED.." |c00E02020"..TEXT__OFF.."|r")
    IH_ShowIncoming = false
  else
    echo(TEXT_INCOMING_HEALS_DISPLAY_TURNED.." |c0060F060"..TEXT__ON.."|r")
    IH_ShowIncoming = true
  end
end

function IH_SwitchOutDisplay()
  if IH_ShowOutgoing then
    echo(TEXT_OUTGOING_HEALS_DISPLAY_TURNED.." |c00E02020"..TEXT__OFF.."|r")
    for i = 1, 40 do
      getglobal("CT_RAMember"..i.."_OH"):Hide()
    end
    IH_ShowOutgoing = false
    
  else
    echo(TEXT_OUTGOING_HEALS_DISPLAY_TURNED.." |c0060F060"..TEXT__ON.."|r")
    IH_ShowOutgoing = true

  end
end

function IH_SwitchMissingDisplay()
  if IH_ShowMissing then
    echo(TEXT_MISSING_LIFE_DISPLAY_TURNED.." |c00E02020"..TEXT__OFF.."|r")
    IH_ShowMissing = false
  else
    echo(TEXT_MISSING_LIFE_DISPLAY_TURNED.." |c0060F060"..TEXT__ON.."|r")
    IH_ShowMissing = true
  end
end



function IH_ShowUsers()
  echo("|c00"..IH_COLOR_CODE..IH_TITLE.."|r "..TEXT_KNOWN_USERS_SMALL..":")
  for playername, version in IH_KnownUsers do
    if version <= 7 then version = "<= 7" end
    echo(playername.." "..TEXT__USING_VERSION.." "..version)
  end
end


function IH_ShowHelp()
  echo("|c00"..IH_COLOR_CODE..IH_TITLE.."|r "..TEXT__COMMANDS..":")
  echo("|c00"..IH_COLOR_CODE.."/"..TEXT__IH.." "..TEXT__IN.."|r "..TEXT_SWITCHES_DISPLAY_OF_INCOMING_HEALS_ON__S__OFF)
  echo("|c00"..IH_COLOR_CODE.."/"..TEXT__IH.." "..TEXT__MISSING.."|r "..TEXT_SWITCHES_DISPLAY_OF_MISSING_LIFE_ON__S__OFF)
  echo("|c00"..IH_COLOR_CODE.."/"..TEXT__IH.." "..TEXT__OUT.."|r "..TEXT_SWITCHES_DISPLAY_OF_OUTGOING_HEALS_ON__S__OFF)
  echo("|c00"..IH_COLOR_CODE.."/"..TEXT__IH.." "..TEXT__RESET.."|r "..TEXT_RESETS_ALL_NUMBERS)
  echo("|c00"..IH_COLOR_CODE.."/"..TEXT__IH.." "..TEXT__USERS.."|r "..TEXT_SHOWS_A_LIST_OF_PLAYERS_USING_INCOMING_HEALS_IN_YOUR_RAID)
  echo("|c00"..IH_COLOR_CODE.."/"..TEXT__IH.." "..TEXT__VERSION.."|r  "..TEXT_SHOWS_VERSION)
end

function IH_ShowVersion()
  echo("|c00"..IH_COLOR_CODE..IH_TITLE.."|r "..TEXT__VERSION.." "..IH_VERSION)
  echo(TEXT_AUTHOR..": "..IH_AUTHOR_NAME.." <"..IH_AUTHOR_GUILD.."> "..TEXT__ON.." "..IH_AUTHOR_REALM)
end



registerEvent("VARIABLES_LOADED", IH_OnVariablesLoaded)
registerEvent("CHAT_MSG_SPELL_SELF_BUFF", IH_OnMsgSpellSelfBuff)



--[[
  CTRA uses the following msg types:
  RN   - buff renewal
  SR   - status request
  S    - status report
  MS   - /rs message
  V    - version check
  SET  - MTTT set
  SET2 - MTTT set
  R    - remove MTTT
  DB     - disband raid
  RESSED - player is ressed
  NORESSED - remove ressed
  RES - ressing player X (res monitor)
  RESNO - stop ressing player X (res monitor)
  CHECKREADY - ready check
  READY
  NOTREADY
  CHECKRLY - rly check
  YARLY - ya rly
  NORLY - no rly
  AFK
  UNAFK
  DND
  UNDND
  ASSISTME
  STOPASSIST
  DURC - request duration
  DUR - send duration
  RSTC - request resistance
  RST -  send resistance
  REAC - request reagents
  REA - send reagents
  ITMC - request item check
  ITM - send item
  CD - cooldown check
  

--]]

